/**
* Checking the basic reflection
* Author: Kaushik Pal
* */
public class Test {
	/**
	 * @param args
	 */
	public static void main(String[] args) {		
			
		// Creating the constructor
		Test inspectclass = new Test();	      

	    try {
	           // Call printDetails class to check the details	
inspectclass.printDetails( Class.forName( "java.io.BufferedWriter" ), 0 );	        	  
	      } catch (ClassNotFoundException e ) 
	      {	    	  
		       System.out.println("Printing exception");
		       e.printStackTrace();
	      } 		
	}
	/**
	 * @param clstype
	 * @param classdepth
	 * This is used to encapsulate the reflection class details
	 */
	public void printDetails(Class clstype, int classdepth ){				
		 // Print the class name passed from main
System.out.println( "Class depth is: " + classdepth + " Class Name is: " + clstype.getName() );
	      
	      // Recurse to get super class details
	      if ( clstype.getSuperclass() != null ){
	    	  // Get all the details
	    	  printDetails( clstype.getSuperclass(), classdepth + 1 );
	      }
	}
}
